function [pathes, e, l] = energy(map_3d, edge_2d, theta)
% [x,y,z] = importMap('D:\astar\codes\matlab\astar-pathplanning-matlab\ڶṩ\0101\0101̵߳.csv');
% [edge_x,edge_y] = importEdge('D:\astar\codes\matlab\astar-pathplanning-matlab\ڶṩ\0101\0101.csv');
% theta = ֱ·бǶ

import config.GlobalConfig;
import calculation.to_standard_poly;
import turn.FishtailTurn;
import turn.BulbTurn;

disp(['energy called with theta', num2str(theta)]);

edge_standard = corrosion(getPoly(edge_2d),...
    GlobalConfig.omega,...
    GlobalConfig.r,...
    theta);

delta_b = GlobalConfig.omega /cos(theta);
k = tan(theta);

edge_standard = getPoly(edge_standard);
edge_x = edge_standard(:,1);
edge_y = edge_standard(:,2);

totle_distance = 0;

[y_min, y_min_ind] = min(edge_y');
[y_max, y_max_ind] = max(edge_y');
totle_line = 0; % 直线做功
totle_circle = 0; % 转角做功
distance_line = 0; % 直线长度
distance_circle = 0; % 转弯长度
b0 = y_max - k * edge_x(y_max_ind);
line_func = [k, -1, b0];
coor = getCoordinate(line_func, edge_standard);
t_coor = coor;
mutiLinestring = [];
bt = b0;
while ~isempty(coor)
    % plot(coor(1,:),coor(2,:));
    mutiLinestring = [{coor}, mutiLinestring];
    bt = bt - delta_b;
    line_func = [k, -1, bt];
    coor = getCoordinate(line_func, edge_standard);
end

bt = b0;
coor = t_coor;
flag = 0;
while ~isempty(coor)
    if flag == 1
        mutiLinestring = [mutiLinestring, {coor}];
    else
        flag = 1;
    end
    bt = bt + delta_b;
    line_func = [k, -1, bt];
    coor = getCoordinate(line_func, edge_standard);
end

length_mutiLinestring = length(mutiLinestring);
if abs(theta) * 2 < pi
    for i = 1:2:length_mutiLinestring
        mutiLinestring{i} = mutiLinestring{i}(end:-1:1,:);
    end
else
    for i = 2:2:length_mutiLinestring
        mutiLinestring{i} = mutiLinestring{i}(end:-1:1,:);
    end
end

mutiline = MutiLine2D(mutiLinestring);
pre = mutiline.data{1};
line_number = length(mutiline.data);
now = mutiline.data{2};
[pathes, next] = FishtailTurn(theta, GlobalConfig.omega, GlobalConfig.r).turn(pre, now, 0);

r = GlobalConfig.r;
omega = GlobalConfig.omega;

for i = 3:line_number
    pre = next;
    now = mutiline.data{i};
    
    [delta_x, psi] = get_delta_x(edge_standard, pre(end, :), theta);
    
    if delta_x >= (r * (1 + cos(psi)) + omega / 2 * (1 + sin(psi)*cos(psi)))
        if (r > omega / 2)
            if (r < (delta_x - omega / 2) / (1 + cos(psi)))
                turing = FishtailTurn(theta, omega, r);
            else
                turing = BulbTurn(theta, omega, r);
            end
        elseif (r == omega / 2)
            turing = UTuring(theta, omega, r);
        else
            turing = FlatTurn(theta, omega, r);
        end
    else
        turing = FishtailTurn(theta, omega, r);
    end
    [y, next]= turing.turn(pre, now, mod(i, 2));
    len_y = length(y);
    pathes = {pathes{:}, y{:}};
    for j = 1:len_y
        length_y = y{j}.length_3d(map_3d, 10);
        if ~isnan(length_y)
            totle_circle = totle_circle + y{j}.length_3d(map_3d, 10);
        end
    end
end
pathes = {pathes{:}, Line2D(next)};
e = totle_line + totle_circle;
l = sum(arrayfun(@(i) i{1}.distance(map_3d, 10), pathes));
end



function res = in_line_area(point, line)
xs = sort([line(1), line(3)]);
ys = sort([line(2), line(4)]);
res = ((xs(1) <= point(1)) && (point(1) <= xs(2))) && ((ys(1) <= line(2)) && (ys(1) <= ys(2)));
end

function res = in_line(point, line)
res = ((line(1) - point(1)) / (line(3) - point(1)) - (line(2) - point(2)) / (line(4) - line(2))) <= 1e-0...
    && in_line_area(point, line);
end

function [delta_x, psi] = get_delta_x(edge, point, theta)
import config.GlobalConfig;

lines = [edge(1:end-1, :), edge(2: end, :)];
    function line = line_of_point(point, lines)
        for i = 1:length(lines)
            if in_line(point, lines(i, :))
                line = lines(i, :);
                break;
            end
        end
    end

line = line_of_point(point, lines);

r = GlobalConfig.r;
omega = GlobalConfig.omega;

line_theta = atan((line(2) - line(4)) / (line(3) - line(1)));

delta_x = (r .* (1 + abs(cos(theta - line_theta))) + (omega / 2));
psi = line_theta - theta;
end
