classdef FishtailTurn  < turn.TurningStrategy
    %TurningStrategy ת䷽ʽ
    %   ˴ʾϸ˵
    
    properties
    end
    
    methods
        function obj = FishtailTurn(theta, omega, r)
            obj = obj@turn.TurningStrategy(theta, omega, r);
        end
        function [y, to_line] = turn(obj, from_line, to_line, dir)
            
            k = tan(obj.theta);
            from  = from_line(end,:);
            to = to_line(1, :);
            
            line_from = [k, -1, from(2)-from(1)*k]; % ʼһ·
            foot1 = getFoot(line_from, to);
            
            line_to = [k, -1, to(2)-to(1)*k];% ֹһ·
            foot2 = getFoot(line_to, from);
            
            a = 0;
            if ~onsegment(from_line, foot1)
                from = foot1;
                from_line = [from_line;from];
            end
            if ~onsegment(to_line, foot2)
                to = foot2;
                to_line = [to;to_line];
            end
            y = Line2D(from_line);
            r = obj.r;
            
            % ԲͬнǶ ȷ 0 < theta < 2 * pi
            if (pi * (3 / 2) > obj.theta) && (obj.theta > pi)
                arc1_start_fix = pi;
                arc1_end_fix = pi;
                arc2_start_fix = pi;
                arc2_end_fix = pi;
            elseif obj.theta > (pi * 3 / 2)
                if dir
                    arc1_start_fix = pi;
                    arc1_end_fix = 0;
                    arc2_start_fix = 0;
                    arc2_end_fix = - pi;
                else
                    arc1_start_fix = 0;
                    arc1_end_fix = - pi;
                    arc2_start_fix = pi;
                    arc2_end_fix =  0;
                end
            else
                arc1_start_fix = 0;
                arc1_end_fix = 0;
                arc2_start_fix = 0;
                arc2_end_fix = 0;
            end
            
            if dir
                arc1.radis = r;
                arc1.point = from + (to-from)*obj.r/obj.omega;
                arc1.startTheta=atan(-1/k) + arc1_start_fix;
                arc1.endTheta=atan(-1/k)+pi/2 + arc1_end_fix;
                
                x0 = arc1.point(1);
                y0 = arc1.point(2);
                p1 = [x0+r*cos(arc1.endTheta), y0+r*sin(arc1.endTheta)];
                
                arc2.radis = obj.r;
                arc2.point = to - (to-from)*obj.r/obj.omega;
                arc2.startTheta=atan(-1/k)+pi/2 + arc2_start_fix;
                arc2.endTheta=atan(-1/k)+pi + arc2_end_fix;
                
                x0 = arc2.point(1);
                y0 = arc2.point(2);
                p2 = [x0+r*cos(arc2.startTheta), y0+r*sin(arc2.startTheta)];
                
                y = {y, Arc(arc1),Line2D([p1;p2]), Arc(arc2)};
                
            else
                
                arc1.radis = obj.r;
                arc1.point = from + (to-from)*obj.r/obj.omega;
                arc1.startTheta=atan(-1/k)+3*pi/2 + arc1_start_fix;
                arc1.endTheta=atan(-1/k)+pi*2 + arc1_end_fix;
                
                x0 = arc1.point(1);
                y0 = arc1.point(2);
                p1 = [x0+r*cos(arc1.startTheta), y0+r*sin(arc1.startTheta)];
                
                arc2.radis = obj.r;
                arc2.point = to - (to-from)*obj.r/obj.omega;
                arc2.startTheta=atan(-1/k)+pi + arc2_start_fix;
                arc2.endTheta=atan(-1/k)+3*pi/2 + arc2_end_fix;
                
                x0 = arc2.point(1);
                y0 = arc2.point(2);
                p2 = [x0+r*cos(arc2.endTheta), y0+r*sin(arc2.endTheta)];
                y = {y, Arc(arc1),Line2D([p1;p2]), Arc(arc2)};
            end
        end
    end
end
