classdef Arc < Graph
    % 圆弧
    properties
    end
    
    methods
        function obj = Arc(data)
            obj = obj@Graph(data);
            %         data.point;  % 圆心
            %         data.radis;  % 半径
            %         data.startTheta; % 起始角度
            %         data.endTeta; % 终止角度（?时针方向为正方向）
        end
        function graphPlot(obj, figureNumber)
            figure(figureNumber)
            hold on
            data = obj.data;
            x0=data.point(1);
            y0=data.point(2);
            r=data.radis;
            if data.startTheta < data.endTheta
                theta=linspace(data.startTheta,data.endTheta);
            else
                theta=linspace(data.endTheta,data.startTheta);
            end
            x=x0+r*cos(theta);
            y=y0+r*sin(theta);
            plot(x,y,'-');
            %             arrow([x(1), y(1)], [x(end), y(end)]);
        end
        
        function l = distance(obj, graph, step)
            data = obj.data;
            x0=data.point(1);
            y0=data.point(2);
            r=data.radis;
            if data.startTheta < data.endTheta
                theta=linspace(data.startTheta,data.endTheta,step);
            else
                theta=linspace(data.endTheta,data.startTheta, step);
            end
            xi=x0+r*cos(theta);
            yi=y0+r*sin(theta);
            x = graph(:, 1);
            y = graph(:, 2);
            z = graph(:, 3);
            zi = griddata(x,y,z,xi,yi, 'nearest');
            points = [xi; yi; zi];
            vecs =  points(:, 2:end) - points(:, 1: end - 1);
            l = sum(vecnorm(vecs));
        end
        
        
        
        function l = length_3d(obj, graph, step)
            import config.GlobalConfig;
            
            data = obj.data;
            x0=data.point(1);
            y0=data.point(2);
            r=data.radis;
            
            if data.startTheta < data.endTheta
                theta=linspace(data.startTheta,data.endTheta,step);
            else
                theta=linspace(data.endTheta,data.startTheta, step);
            end
            
            xi=x0+r*cos(theta);
            yi=y0+r*sin(theta);
            x = graph(:, 1);
            y = graph(:, 2);
            z = graph(:, 3);
            zi = griddata(x,y,z,xi,yi, 'nearest');
            
            points = [xi; yi; zi];
            vectors =  points(:, 2:end) - points(:, 1: end - 1);
            
            delta_l = vecnorm(vectors(1:2, :));
            delta_l(isnan(delta_l)) = 0;
            
            W_G = vectors(3) * GlobalConfig.mg; % 重力做功
            W_G(isnan(W_G)) = 0;
            
            W_F = GlobalConfig.mg * GlobalConfig.miu * delta_l;
            
            W = sum(abs(W_G + W_F));
            l = W;
        end
    end
end

