classdef Line2D < Graph
    properties
    end
    
    methods
        function obj = Line2D(data)
            obj = obj@Graph(data);
        end
        function graphPlot(obj, figureNumber)
            figure(figureNumber)
            hold on
            data = obj.data;
            plot(data(:,1), data(:,2));  
        end
        
        function l = distance(obj, graph, step)
            data = obj.data;
            x = graph(:, 1);
            y = graph(:, 2);
            z = graph(:, 3);
            xi=linspace(data(1, 1),data(end, 1), step);
            yi=linspace(data(1, 2),data(end, 2), step);
            zi = griddata(x,y,z,xi,yi, 'nearest');
            points = [xi;yi;zi];
            vecs = points(:, 2: end) - points(:, 1: end - 1);
            l = sum(vecnorm(vecs));
        end
        
        function l = length(obj)
            data = obj.data;
            l = norm(data(2,:) - data(1,:));
        end
        
        function l = length_3d(obj, graph, step)
            import config.GlobalConfig;
            
            data = obj.data;
            x = graph(:, 1);
            y = graph(:, 2);
            z = graph(:, 3);
            
            xi=linspace(data(1, 1),data(end, 1), step);
            yi=linspace(data(1, 2),data(end, 2), step);
            zi = griddata(x,y,z,xi,yi, 'nearest');
            
            points = [xi; yi; zi];
            vectors =  points(:, 2:end) - points(:, 1: end - 1);
            
            delta_l = vecnorm(vectors(1:2, :));
            delta_l(isnan(delta_l)) = 0;
            
            W_G = vectors(3) * GlobalConfig.mg; % 
            W_G(isnan(W_G)) = 0;
            
            W_F = GlobalConfig.mg * GlobalConfig.miu * delta_l;
            
            W = sum(abs(W_G + W_F));
            l = W;
        end
    end
end
