clc
clear
close all

addpath './transform/'
addpath './between_farm/'

pathdir = '.\2020.02.11';

height_map = [pathdir, '/0', '2','0', '2','/0', '2','0','2','̵߳.csv'];
edge_map = [pathdir, '/0','2','0','2','/0','2','0','2','߽.csv'];
[x, y, z] = importMap(height_map);
[edge_x, edge_y] = importEdge(edge_map);

earth_redius = 6371000;
origin = [127.0577; 42.3173];
edge_points = longlat2meter([edge_x, edge_y]', earth_redius, origin);

edge_x_meter = edge_points(1, :)';
edge_y_meter = edge_points(2, :)';

height_locations = longlat2meter([x, y]', earth_redius, origin);
x_meter = height_locations(1, :)';
y_meter = height_locations(2, :)';

pathes = edge2pathes([edge_x_meter, edge_y_meter]);

figure(1);
hold on

for i=1:length(pathes) - 1
    line([pathes(i, 1), pathes(i, 3)], [pathes(i, 2), pathes(i, 4)])
end