clc
clear
close all

addpath './transform/'

pathdir = '.\2020.02.11';

axis equal

height_map = [pathdir, '/0', '2','0', '2','/0', '2','0','2','̵߳.csv'];
edge_map = [pathdir, '/0','2','0','2','/0','2','0','2','߽.csv'];
[x, y, z] = importMap(height_map);
[edge_x, edge_y] = importEdge(edge_map);

earth_redius = 6371000;
origin = [127.0577; 42.3173];
edge_points = longlat2meter([edge_x, edge_y]', earth_redius, origin);

edge_x_meter = edge_points(1, :)';
edge_y_meter = edge_points(2, :)';

heigt_locations = longlat2meter([x, y]', earth_redius, origin);
x_meter = heigt_locations(1, :)';

y_meter = heigt_locations(2, :)';

cases = arrayfun(@(i) [i, ((pi * 1 / 2) * i) - pi / 4], 1:4, 'UniformOutput', false);

for i = 1:4
    img_index = cases{i}(1);
    angle = cases{i}(2);
    [path, len] = main_plot(x_meter, y_meter, z, edge_x_meter, edge_y_meter, img_index, angle);
end
