clear;

import opitimization.single_opitimization;
import transform.longlat2meter;
import calculation.energy;

pathdir = '2020.04.25';

height_map = [pathdir, '/0', '1','0', '1','/0', '1','0','1','̵߳.csv'];
edge_map = [pathdir, '/0','1','0','1','/0','1','0','1','߽.csv'];
[x, y, z] = importMap(height_map);
[edge_x, edge_y] = importEdge(edge_map);

earth_redius = 6371000;  % 뾶
origin = [127.1563; 42.3230];  %  ο

edge_points = longlat2meter([edge_x, edge_y]', earth_redius, origin);

edge_x_meter = edge_points(1, :)';
edge_y_meter = edge_points(2, :)';

heigt_locations = longlat2meter([x, y]', earth_redius, origin);
x_meter = heigt_locations(1, :)';
y_meter = heigt_locations(2, :)';

[angle, len, entrance, export, history, l] = single_opitimization([x_meter, y_meter, z],...
    [edge_x_meter, edge_y_meter], 46, 1);

main_plot(x,y,z,edge_x_meter,edge_y_meter, 1, angle);
figure(2);
stem(history(1, :) * 360 / (2 * pi), history(2, :));
title('energy');
figure(3);
stem(history(1, :) * 360 / (2 * pi), history(3, :));
title('length');

disp("best angle is " + angle * 360 / (2 * pi));
disp("best length is " + l);
disp("best energy is " + len);
disp("best entrance is " + entrance(1) + " " + entrance(2));
disp("best export is " + export(1) + " " + export(2));
