function [path, len, distance] = solvePath(map_3d, edge, theta, turing, omega, fig)

import config.GlobalConfig;
import calculation.to_standard_poly;
import turn.FishtailTurn;
import turn.BulbTurn;

delta_b = omega /cos(theta);
k = tan(theta);

edge = getPoly(edge);
edge_x = edge(:,1);
edge_y = edge(:,2);

totle_distance = 0;

[y_min, y_min_ind] = min(edge_y');
[y_max, y_max_ind] = max(edge_y');
totle_line = 0; 
totle_circle = 0; 
distance_line = 0; 
distance_circle = 0; 
b0 = y_max - k * edge_x(y_max_ind);
line_func = [k, -1, b0];
coor = getCoordinate(line_func, edge);
t_coor = coor;
mutiLinestring = [];
bt = b0;
if fig ~= 0
    figure(fig)
end
hold on
while ~isempty(coor)
    % plot(coor(1,:),coor(2,:));
    mutiLinestring = [{coor}, mutiLinestring];
    bt = bt - delta_b;
    line_func = [k, -1, bt];
    coor = getCoordinate(line_func, edge);
end

bt = b0;
coor = t_coor;
flag = 0;
while ~isempty(coor)
    if flag == 1
        mutiLinestring = [mutiLinestring, {coor}];
    else
        flag = 1;
    end
    bt = bt + delta_b;
    line_func = [k, -1, bt];
    coor = getCoordinate(line_func, edge);
end

length_mutiLinestring = length(mutiLinestring);
if abs(theta) * 2 < pi
    for i = 1:2:length_mutiLinestring
        mutiLinestring{i} = mutiLinestring{i}(end:-1:1,:);
    end
else
    for i = 2:2:length_mutiLinestring
        mutiLinestring{i} = mutiLinestring{i}(end:-1:1,:);
    end
end

mutiline = MutiLine2D(mutiLinestring);
pre = mutiline.data{1};
line_number = length(mutiline.data);
now = mutiline.data{2};
[path, next] = turing.turn(pre, now, 0);

r = GlobalConfig.r;

for i = 3:line_number
    pre = next;
    now = mutiline.data{i};
    
    [delta_x, psi] = get_delta_x(edge, pre(end, :), theta);
    
    if (delta_x >= r * (1 + cos(psi))) + omega / 2 * (1 + sin(psi)*cos(psi))
        if (r > omega / 2)
            if (r < (delta_x - omega / 2) / (1 + cos(psi)))
                turing = FishtailTurn(theta, omega, r);
            else
                turing = BulbTurn(theta, omega, r);
            end
        elseif (r == omega / 2)
            turing = UTuring(theta, omega, r);
        else
            turing = FlatTurn(theta, omega, r);
        end
    else
        turing = FishtailTurn(theta, omega, r);
    end
    
    [y, next]= turing.turn(pre, now, mod(i, 2));
    len_y = length(y);
    path = {path{:}, y{:}};
    for j = 1:len_y
        length_y = y{j}.length_3d(map_3d, 10);
        distance_y = y{j}.distance(map_3d, 10);
        if ~isnan(length_y)
            totle_circle = totle_circle + y{j}.length_3d(map_3d, 10);
            totle_distance = totle_distance + distance_y;
        end
    end
end
path = {path{:}, Line2D(next)};
len = totle_line + totle_circle;
distance = totle_distance;
end

function res = in_line_area(point, line)
xs = sort([line(1), line(3)]);
ys = sort([line(2), line(4)]);
res = ((xs(1) <= point(1)) && (point(1) <= xs(2))) && ((ys(1) <= line(2)) && (ys(1) <= ys(2)));
end

function res = in_line(point, line)
res = ((line(1) - point(1)) / (line(3) - point(1)) - (line(2) - point(2)) / (line(4) - line(2))) <= 1e-0...
    && in_line_area(point, line);
end

function [delta_x, psi] = get_delta_x(edge, point, theta)
import config.GlobalConfig;
lines = [edge(1:end-1, :), edge(2: end, :)];
    function line = line_of_point(point, lines)
        for i = 1:length(lines)
            if in_line(point, lines(i, :))
                line = lines(i, :);
                break;
            end
        end
    end

line = line_of_point(point, lines);

r = GlobalConfig.r;
omega = GlobalConfig.omega;

line_theta = atan((line(2) - line(4)) / (line(3) - line(1)));

delta_x = (r .* (1 + abs(cos(theta - line_theta))) + (omega / 2));
psi = line_theta - theta;
end
